crashpad::MinidumpSimpleStringDictionaryWriter Class Referencefinal

The writer for a MinidumpSimpleStringDictionary object in a minidump file, containing a list of MinidumpSimpleStringDictionaryEntry objects. More...

`#include "minidump/minidump_simple_string_dictionary_writer.h"`

Inheritance diagram for crashpad::MinidumpSimpleStringDictionaryWriter:

## Public Member Functions

void | InitializeFromMap (const std::map< std::string, std::string > &map)
| Adds an initialized MinidumpSimpleStringDictionaryEntryWriter for each key-value pair in map to the MinidumpSimpleStringDictionary. More...
void | AddEntry (std::unique_ptr< MinidumpSimpleStringDictionaryEntryWriter > entry)
| Adds a MinidumpSimpleStringDictionaryEntryWriter to the MinidumpSimpleStringDictionary. More...
bool | IsUseful () const
| Determines whether the object is useful. More...
Public Member Functions inherited from crashpad::internal::MinidumpWritable
virtual bool | WriteEverything (FileWriterInterface *file_writer)
| Writes an object and all of its children to a minidump file. More...
void | RegisterRVA (RVA *rva)
| Registers a file offset pointer as one that should point to the object on which this method is called. More...
void | RegisterLocationDescriptor (MINIDUMP_LOCATION_DESCRIPTOR *location_descriptor)
| Registers a location descriptor as one that should point to the object on which this method is called. More...

## Protected Member Functions

bool | Freeze () override
| Transitions the object from kStateMutable to kStateFrozen. More...
size_t | SizeOfObject () override
| Returns the amount of space that this object will consume when written to a minidump file, in bytes, not including any leading or trailing padding necessary to maintain proper alignment. More...
std::vector< MinidumpWritable * > | Children () override
| Returns the object’s children. More...
bool | WriteObject (FileWriterInterface *file_writer) override
| Writes the object’s content. More...
Protected Member Functions inherited from crashpad::internal::MinidumpWritable
State | state () const
| The state of the object.
virtual size_t | Alignment ()
| Returns the object’s desired byte-boundary alignment. More...
virtual Phase | WritePhase ()
| Returns the object’s desired write phase. More...
size_t | WillWriteAtOffset (Phase phase, FileOffset *offset, std::vector< MinidumpWritable *> *write_sequence)
| Prepares the object to be written at a known file offset, transitioning it from kStateFrozen to kStateWritable. More...
virtual bool | WillWriteAtOffsetImpl (FileOffset offset)
| Called once an object’s writable file offset is determined, as it transitions into kStateWritable. More...
bool | WritePaddingAndObject (FileWriterInterface *file_writer)
| Writes the object, transitioning it from kStateWritable to kStateWritten. More...

## Additional Inherited Members

Protected Types inherited from crashpad::internal::MinidumpWritable
enum | State
| Identifies the state of an object. More...
enum | Phase
| Identifies the phase during which an object will be written to a minidump file. More...
Static Protected Attributes inherited from crashpad::internal::MinidumpWritable
static constexpr size_t | kInvalidSize = std::numeric_limits<size_t>::max()
| A size value used to signal failure by methods that return `size_t`.

## Detailed Description

The writer for a MinidumpSimpleStringDictionary object in a minidump file, containing a list of MinidumpSimpleStringDictionaryEntry objects.

Because this class writes a representatin of a dictionary, the order of entries is insignificant. Entries may be written in any order.

## Member Function Documentation

## AddEntry()

void crashpad::MinidumpSimpleStringDictionaryWriter::AddEntry | ( | std::unique_ptr< MinidumpSimpleStringDictionaryEntryWriter > | entry | ) |

Adds a MinidumpSimpleStringDictionaryEntryWriter to the MinidumpSimpleStringDictionary.

This object takes ownership of entry and becomes its parent in the overall tree of internal::MinidumpWritable objects.

If the key contained in entry duplicates the key of an entry already present in the MinidumpSimpleStringDictionary, the new entry will replace the previous one.

Note
  Valid in kStateMutable.

## Children()

std::vector< internal::MinidumpWritable * > crashpad::MinidumpSimpleStringDictionaryWriter::Children | ( |  | ) |

overrideprotectedvirtual

Returns the object’s children.

Note
  Valid in kStateFrozen or any subsequent state.

Reimplemented from crashpad::internal::MinidumpWritable.

## Freeze()

bool crashpad::MinidumpSimpleStringDictionaryWriter::Freeze | ( |  | ) |

overrideprotectedvirtual

Transitions the object from kStateMutable to kStateFrozen.

The default implementation marks the object as frozen and recursively calls Freeze() on all of its children. Subclasses may override this method to perform processing that should only be done once callers have finished populating an object with data. Typically, a subclass implementation would call RegisterRVA() or RegisterLocationDescriptor() on other objects as appropriate, because at the time Freeze() runs, the in-memory locations of RVAs and location descriptors are known and will not change for the remaining duration of an object’s lifetime.

Returns
  `true` on success. `false` on failure, with an appropriate message logged.

Reimplemented from crashpad::internal::MinidumpWritable.

## InitializeFromMap()

void crashpad::MinidumpSimpleStringDictionaryWriter::InitializeFromMap | ( | const std::map< std::string, std::string > & | map | ) |

Adds an initialized MinidumpSimpleStringDictionaryEntryWriter for each key-value pair in map to the MinidumpSimpleStringDictionary.

Parameters

  [in] | map | The map to use as source data.

Note
  Valid in kStateMutable. No mutator methods may be called before this method, and it is not normally necessary to call any mutator methods after this method.

## IsUseful()

bool crashpad::MinidumpSimpleStringDictionaryWriter::IsUseful | ( |  | ) | const

Determines whether the object is useful.

A useful object is one that carries data that makes a meaningful contribution to a minidump file. An object carrying entries would be considered useful.

Returns
  `true` if the object is useful, `false` otherwise.

## SizeOfObject()

size_t crashpad::MinidumpSimpleStringDictionaryWriter::SizeOfObject | ( |  | ) |

overrideprotectedvirtual

Returns the amount of space that this object will consume when written to a minidump file, in bytes, not including any leading or trailing padding necessary to maintain proper alignment.

Note
  Valid in kStateFrozen or any subsequent state.

Implements crashpad::internal::MinidumpWritable.

## WriteObject()

bool crashpad::MinidumpSimpleStringDictionaryWriter::WriteObject | ( | FileWriterInterface * | file_writer | ) |

overrideprotectedvirtual

Writes the object’s content.

Parameters

  [in] | file_writer | The file writer to receive the object’s content.

Returns
  `true` on success. `false` on error, indicating that the content could not be written to the minidump file.

Note
  Valid in kStateWritable. The object will transition to kStateWritten after this method returns.

Implements crashpad::internal::MinidumpWritable.

The documentation for this class was generated from the following files:

- minidump/minidump_simple_string_dictionary_writer.h
- minidump/minidump_simple_string_dictionary_writer.cc